



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>problem：vue组件局部刷新，在组件销毁（destroyed）时取消刷新无效问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">problem：vue组件局部刷新，在组件销毁（destroyed）时取消刷新无效问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 08:46:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>场景：</p>
<p>一个群发消息列表（数组）</p>
<p>列表下有多条消息（元素）</p>
<p>每条正在发送的消息数据状态需要实时刷新，发送完成时需要显示成功提示符合且不需要刷新，然后3秒消失。首次显示列表时，已经成功的状态不显示这个成功提示符。</p>
<p>1、定位确定采用局部刷新</p>
<p>2、进入消息列表请求获取列表数据的接口，完成发送的消息不需显示完成状态</p>
<p>3、正在发送的消息首次渲染时就调用setTimeout轮询刷新当前消息的接口，完成时，显示完成状态（新增一个完成状态的字段）</p>
<p>4、页面销毁时，还在发送的消息也取消刷新</p>
<p>误区：</p>
<p>1、每条消息没有抽成一个单独的组件，想要首次渲染组件调用刷新接口时，只能通过定义全局map变量来映射每条消息的刷新接口的定时器，明显增加业务开发的复杂度，增加了一些不确定性的bug风险。</p>
<p>每条消息抽成组件之后，就可以在组件中的mounted中去调用刷新的接口，页面销毁时取消刷新可以在destroyed里面去销毁。</p>
<p>2、这里的一个误区是在destroyed里面去清除定时器的id，导致调用了destroyed钩子刷新的定时器还是无法清除。将定时器id当做一个属性值存在了每条数据所属的对象中，然后在子组件（每条消息所属的）中的destroyed中去读取该对象的当前的定时器属性，因为读出来是undifined，其实并没有拿到当前消息正在执行的定时器，所以清除不掉。</p>
<p>组件使用有误，每一个组件都是一个独立的元素，其中定义的变量也是私有的，定时器id定在当前组件的data中就可以了，不需要再在数组中的每一条消息中定一个专属的定时器id。</p>
<p>抽象出来的简单版刷新数据，5秒后取消刷新。</p>
<div>
<pre class="prettyprint linenums">let intervalId = null<br />
function init() {<br />
    this.refresh()<br />
}

function refresh() {<br />
   intervalId = setTimeout(() =&gt; {<br />
         this.getRefreshData()<br />
     }, 2000);<br />
}

function getRefreshData() {<br />
    console.log('start get data.....', intervalId)<br />
    setTimeout(() =&gt; {<br />
        console.log('get data.....')<br />
        this.refresh()<br />
    }, 100);

}

function stopRefresh() {<br />
    console.log('stop....', intervalId)<br />
    clearInterval(intervalId)<br />
}

this.init()<br />
setTimeout(() =&gt; {<br />
    this.stopRefresh()<br />
}, 5000);</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/31q22xq7.html">Unity3d学习 预设体&lpar;prefab&rpar;的一些理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jzkll8.html">前端页面开发，最低兼容IE 8的多设备跨平台问题解决！</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd5d0v9.html">npapi插件开发流程与实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvr5jy8.html">【Java讨论】引用类型赋值为null对加速垃圾回收的作用&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyndpx9.html">NYOJ题目806HEIHEI的心情</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8elj0eq.html">Android Studio 查看密钥库证书指纹SHA1</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4on438.html">---Under Ubuntu 14&period;04</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1ooxz9.html">【Mood-4】心静是一门艺术</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0r1zeq.html">bootstrap paginator 与 bootstrap3兼容</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j04dwwq.html">Sublime编辑器 前端 必备插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mp6ojq.html">JS笔记 入门第一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zzlng9.html">redis入门（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/950j6w08.html">C&num;实现rabbitmq 延迟队列功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1r5g1q.html">ABAP 7&period;4 新语法-内嵌生命和内表操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m64m38.html">Topologies on product spaces of &dollar;&bsol;mathbb&lbrace;R&rcub;&dollar; and their relationships</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk1lde8.html">Linux--前后端分离部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2ve7z9.html">百度翻译新API C&num;版在 winform，Asp&period;Net的小程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1ejeq.html">JavaScript 笔记（二） 正则表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j4xv0q.html">angularjs优化方略</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ejmvq.html">第七章&vert;7&period;4并发编程&vert; I&sol;O模型</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2j22z9.html">js中用户名的正则（字符，数字，下划线，减号）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r56nmdq.html">&lpar;01&rpar; 什么是Spring Boot</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvnle38.html">ceph Luminous版手动安装零散记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2yj4rq.html">Solr安装使用教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w3jygq.html">vue教程自学笔记（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o2n6e8.html">L1-057 PTA使我精神焕发</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvnrwz8.html">LINUX 录制屏幕制作gif动态图工具peek</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy63pd9.html">C&num;实现焦点变色</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1vl5g9.html">大大维的游戏机计划1--贪吃蛇v1</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy66gv9.html">tail语法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
